// Timer driver for nRF52840 | gat 11/04/23
#ifndef _TIMER_H_
#define _TIMER_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "nrf52840_bitfields.h"

typedef enum
{
	Timer0, Timer1,	Timer2,	Timer3,	Timer4
}Timer_Channel;

typedef enum
{
	Bits16, Bits8, Bits24, Bits32
}Timer_Bitmode;

typedef enum
{
	CC0,CC1,CC2,CC3,CC4,CC5
}Timer_Compare_Channel;

typedef enum
{
	None, Clear, Stop
}Timer_Compare_Shortcut;

typedef struct
{
	Timer_Channel Channel;
	Timer_Compare_Channel Compare_Channel;
	Timer_Compare_Shortcut Shortcut;
	unsigned int CompareValue;
	void (*Callback)(void);
}Timer_Compare_Config;

typedef struct
{
	Timer_Channel Channel;
	Timer_Bitmode Bitmode;
	unsigned char Prescaler; // 0 to 9
}Timer_Config;

typedef struct
{
	Timer_Channel Channel;
	Timer_Bitmode Bitmode;
	Timer_Compare_Channel Compare_Channel;
	unsigned int CompareValue;
	void (*Callback)(void);
}Counter_Config;

void Timer_Setup(Timer_Config cfg);

void Counter_Setup(Counter_Config cfg);

void Counter_Clear(Timer_Channel chann);

void Timer_Set_Compare(Timer_Compare_Config cfg);

void Timer_Start(Timer_Channel ch);

#ifdef __cplusplus
}
#endif

#endif //_TIMER_H_
