#include "bootload.h"
#include "nrf.h"
#include "FreeRTOS.h"
#include "task.h"

#define REGVAL_SKIP_BTL 0x00U // NRF_POWER->GPREGRET register value to ask the daemon to jump in app
#define REGVAL_STAY_BTL 0xB1U // NRF_POWER->GPREGRET register value to ask the daemon to stay in btl

void bootload_OnReset(void)
{
	NRF_POWER->GPREGRET2 = 0;
	NRF_UART0->ENABLE = 0;
}

void go_to_bootloader(unsigned char flag)
{
	taskENTER_CRITICAL(); // We dont want to leave once we are here
	User_Regret->DAE_BOOTLOAD = flag;
	DFU_Regret = REGVAL_STAY_BTL;
	NVIC_SystemReset();
}
