// SHT3X, Temp. Rel. Hum. Transducer Middleware | gat 23/06/23
#ifndef _TRH_HPP_
#define _TRH_HPP_

typedef enum {
	TRH_Success,
	TRH_Timeout,
	TRH_MutexError
} TRH_Return;

class TRH
{
	public:
	static bool Detect(void);
	static void Break(void);
	static bool IsDetected(void);
	static void ReadData(void);
	static void StartBlocking(void);
	static void Start(void);
	static TRH_Return Read(void);
	static unsigned char* GetDataPtr(void);
	static void GetTemperatureSample(unsigned char* data_ptr);
	static void GetHumiditySample(unsigned char* data_ptr);
	private:
	static void Enable(void);
	static void Disable(void);
};
#endif